// totally unclean experimental colection of bytes...

uniform float uNear;
uniform float uFar;

uniform float uTime;
uniform float uMinAlpha;
uniform vec4  uWaterColor;
uniform vec4  uWildWaterColor;

uniform sampler3D       Noise1;
uniform samplerCube     SkyBox;
uniform sampler2DShadow TexShadow;
uniform float           uTexShadowSize;
uniform int             uShowShadows;

varying vec4            vTexCoordShadow;
varying vec3            vNormal;
varying vec3            vLight;
varying vec3            vHalfVec;
varying vec4            vDiffuse, vAmbient;
varying vec3            vPos;
varying vec4            vEye;

// Performs 4-sample percentage closer filtering (PCF)
float pcf (vec3 shadow_coord)
{
	float resolution = 1.0 / uTexShadowSize;	// size of a texel in texture coordinates
	
	// locate lowerleft-texel location
	vec2 texel_coord = max(shadow_coord.st * uTexShadowSize - 0.5, 0.0);
	vec3 lltexel = vec3((floor(texel_coord) + 0.5) * resolution, shadow_coord.p);
	
	// take 4 samples
	float sample1 = shadow2D(TexShadow, lltexel).x,
	      sample2 = shadow2D(TexShadow, lltexel + vec3(resolution, 0.0, 0.0)).x,
	      sample3 = shadow2D(TexShadow, lltexel + vec3(0.0, resolution, 0.0)).x,
	      sample4 = shadow2D(TexShadow, lltexel + vec3(resolution, resolution, 0.0)).x;
	
	// take a weighted average of them, using bilinear filtering
	vec2 factor = fract(texel_coord);
	return (1.0-factor.t) * ((1.0-factor.s) * sample1 + factor.s * sample2) +
	       factor.t       * ((1.0-factor.s) * sample3 + factor.s * sample4);
}

void main(void)
{
  vec3 n,halfV;
  float NdotL,NdotHV;
  
  // uprava normaly pro bumpmaping
  float tp=vPos.z/10.0;
  vec4 noisy0 = texture3D(Noise1,vec3(vPos.x*0.7,vPos.y*0.7,uTime)).rgba*2.0-1.0;
  vec4 noisy1 = texture3D(Noise1,vec3(vPos.x*0.1,vPos.y*0.1,uTime+tp)).rgba*2.0-1.0;
  vec4 noisy2 = texture3D(Noise1,vec3(vPos.x*0.3,vPos.y*0.3,uTime+tp)).rgba*2.0-1.0;

  vec4 noisy=mix(vec4(normalize(noisy1.rgb),noisy1.w),vec4(normalize(noisy2.rgb),noisy2.w),0.5);
  noisy=mix(noisy,normalize(noisy0),0.2);
  vec4 noisy_pre=noisy;
  noisy*=(1.1-vNormal.z)*5.0;
  noisy.z=0.0;
  n = normalize(gl_NormalMatrix*(vNormal+noisy.xyz*0.3));
  vec4 cube_color = textureCube(SkyBox, normalize(gl_TexCoord[0].xyz+noisy.xyz)).aaaa*0.5;

  // vypocet vysledne barvy
  float xxx=(1.0-clamp(pow(dot(noisy_pre.xy,normalize(vEye.xyz).xy)*1.0,0.5),0.0,1.0)*0.4);
  NdotL = max(dot(n,vLight),0.0);
  vec4 color_x=mix(uWaterColor,uWildWaterColor,1.0-vNormal.z); // zakladni slozka vsudypritomneho svetla
  color_x=color_x+cube_color;
  vec4 color = color_x/4.0;
  //color_x*=NdotL;
 
	// Determine if this fragment is within the area affected by the shadow map
	float shadow = 1.0;
	vec4 shadow_coord = vTexCoordShadow;
	if(uShowShadows==1 && abs(shadow_coord.s) < abs(shadow_coord.q) &&
		abs(shadow_coord.t) < abs(shadow_coord.q) &&
		shadow_coord.p > 0.0)
	{
		// Perform homogenous divide
		shadow_coord /= shadow_coord.q;
		// Map from NDC to viewport
		shadow_coord.stp = shadow_coord.stp;
		// Lookup shadow value
		shadow = pcf(shadow_coord.stp);
	}

  // pokud je to osvetleno
  if (NdotL > 0.0) {
    vec4 color_l = color_x*NdotL;    // normalni osvetleni
//    color_l = color_l*max(cube_color.r*0.85 + cube_color.g*0.5,1.0);       // kvuli prebijeni textury svetlem
    
    halfV = normalize(vHalfVec);      // zbytek pridava odlesky
    NdotHV = max(dot(n,halfV),0.0);
    NdotHV=pow(NdotHV,10.0);          // zostreni odlesku
    color_l += gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(NdotHV, gl_FrontMaterial.shininess) * shadow;
  
    color += color_l*max(shadow,0.7);
  }

  // zapis vysledku
  float color_alpha=min((color.r*2.0+color.g*2.0+color.b)/5.0, 1.0);
  float slope_alpha=(0.7+(1.0-vNormal.z)/3.0);
  float alpha=max(slope_alpha, color_alpha);
  color.a=pow(alpha,1.5)*xxx;
  gl_FragColor=color*xxx;
  // XXX
  // gl_FragDepth=gl_FragCoord.z + noisy.w*((gl_FragCoord.z*uNear)/(uFar-uNear))*0.1;

//  gl_FragColor=vec4(noisy.w,noisy.w,noisy.w,1);
//  if(1==1)
//    discard;
}
